Generic Value List management

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Data Structures | Typedefs | Functions
Generic Value List management
Eina » Data Types » Containers » Generic Value Storage

## Data Structures
struct | _Eina_Value_List
| Used to store the list and its subtype. More...

## Typedefs
typedef struct _Eina_Value_List | Eina_Value_List
| Value type for EINA_VALUE_TYPE_LIST. More...

## Functions
Eina_Value * | eina_value_list_new (const Eina_Value_Type *subtype)
| Create generic value storage of type list. More...
static Eina_Bool | eina_value_list_setup (Eina_Value *value, const Eina_Value_Type *subtype)
| Initialize generic value storage of type list. More...
static unsigned int | eina_value_list_count (const Eina_Value *value)
| Query number of elements in value of list type. More...
static Eina_Bool | eina_value_list_remove (Eina_Value *value, unsigned int position)
| Remove element at given position in value of list type. More...
static Eina_Bool | eina_value_list_set (Eina_Value *value, unsigned int position,...)
| Set the generic value in an list member. More...
static Eina_Bool | eina_value_list_get (const Eina_Value *value, unsigned int position,...)
| Get the generic value from an list member. More...
static Eina_Bool | eina_value_list_insert (Eina_Value *value, unsigned int position,...)
| Insert the generic value in an list member position. More...
static Eina_Bool | eina_value_list_append (Eina_Value *value,...)
| Append the generic value in an list. More...
static Eina_Bool | eina_value_list_vset (Eina_Value *value, unsigned int position, va_list args)
| Set the generic value in an list member. More...
static Eina_Bool | eina_value_list_vget (const Eina_Value *value, unsigned int position, va_list args)
| Get the generic value from an list member. More...
static Eina_Bool | eina_value_list_vinsert (Eina_Value *value, unsigned int position, va_list args)
| Insert the generic value in an list member position. More...
static Eina_Bool | eina_value_list_vappend (Eina_Value *value, va_list args)
| Append the generic value in an list. More...
static Eina_Bool | eina_value_list_pset (Eina_Value *value, unsigned int position, const void *ptr)
| Set the generic value in an list member from pointer. More...
static Eina_Bool | eina_value_list_pget (const Eina_Value *value, unsigned int position, void *ptr)
| Get the generic value to pointer from an list member. More...
static Eina_Bool | eina_value_list_pinsert (Eina_Value *value, unsigned int position, const void *ptr)
| Insert the generic value in an list member position from pointer. More...
static Eina_Bool | eina_value_list_pappend (Eina_Value *value, const void *ptr)
| Append the generic value in an list from pointer. More...

## Detailed Description

## Typedef Documentation

Eina_Value_List

Value type for EINA_VALUE_TYPE_LIST.

See also
  _Eina_Value_List explains fields.

Since
  1.2

## Function Documentation

Eina_Value* eina_value_list_new | ( | const Eina_Value_Type * | subtype | ) |

Create generic value storage of type list.

Parameters

  subtype | how to manage this list members.

Returns
  The new value or `NULL` on failure.

Create a new generic value storage of type list. The members are managed using the description specified by subtype.

On failure, `NULL` is returned.

Note
  this creates from mempool and then uses eina_value_list_setup().

See also
  eina_value_free()
  eina_value_list_setup()

Since
  1.2

References eina_mempool_free(), eina_mempool_malloc(), eina_value_list_setup(), and eina_value_type_check().

static Eina_Bool eina_value_list_setup | ( | Eina_Value * | value,
|  | const Eina_Value_Type * | subtype
| ) |  |
| inlinestatic

Initialize generic value storage of type list.

Parameters

  value | value object
  subtype | how to manage this list members.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

Initializes new generic value storage of type list with the given subtype.

This is the same as calling eina_value_set() with EINA_VALUE_TYPE_LIST followed by eina_value_pset() with the Eina_Value_List description configured.

Note
  Existing contents are ignored! If the value was previously used, then use eina_value_flush() first.

On failure, EINA_FALSE is returned.

See also
  eina_value_flush()

Since
  1.2

Referenced by eina_value_list_new().

static unsigned int eina_value_list_count | ( | const Eina_Value * | value | ) |
| inlinestatic

Query number of elements in value of list type.

Parameters

  value | value object.

Returns
  number of child elements.

Since
  1.2

static Eina_Bool eina_value_list_remove | ( | Eina_Value * | value,
|  | unsigned int | position
| ) |  |
| inlinestatic

Remove element at given position in value of list type.

Parameters

  value | value object.
  position | index of the member

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

Since
  1.2

static Eina_Bool eina_value_list_set | ( | Eina_Value * | value,
|  | unsigned int | position,
|  |  | ...
| ) |  |
| inlinestatic

Set the generic value in an list member.

Parameters

  value | source value object
  position | index of the member

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The variable argument is dependent on chosen subtype. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char
- EINA_VALUE_TYPE_USHORT: unsigned short
- EINA_VALUE_TYPE_UINT: unsigned int
- EINA_VALUE_TYPE_ULONG: unsigned long
- EINA_VALUE_TYPE_UINT64: uint64_t
- EINA_VALUE_TYPE_CHAR: char
- EINA_VALUE_TYPE_SHORT: short
- EINA_VALUE_TYPE_INT: int
- EINA_VALUE_TYPE_LONG: long
- EINA_VALUE_TYPE_INT64: int64_t
- EINA_VALUE_TYPE_FLOAT: float
- EINA_VALUE_TYPE_DOUBLE: double
- EINA_VALUE_TYPE_STRINGSHARE: const char *
- EINA_VALUE_TYPE_STRING: const char *
- EINA_VALUE_TYPE_LIST: Eina_Value_List
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash
- EINA_VALUE_TYPE_TIMEVAL: struct timeval
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x;
3
4 eina_value_list_append(value, 1234);
5 eina_value_list_set(value, 0, 5678);
6 eina_value_list_get(value, 0, &x);
7 eina_value_free(value);

See also
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_pset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_get | ( | const Eina_Value * | value,
|  | unsigned int | position,
|  |  | ...
| ) |  |
| inlinestatic

Get the generic value from an list member.

Parameters

  value | source value object
  position | index of the member

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The value is returned in the variable argument parameter, the actual value is type-dependent, but usually it will be what is stored inside the object. There shouldn't be any memory allocation, thus the contents should not be freed.

The variable argument is dependent on chosen subtype. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char*
- EINA_VALUE_TYPE_USHORT: unsigned short*
- EINA_VALUE_TYPE_UINT: unsigned int*
- EINA_VALUE_TYPE_ULONG: unsigned long*
- EINA_VALUE_TYPE_UINT64: uint64_t*
- EINA_VALUE_TYPE_CHAR: char*
- EINA_VALUE_TYPE_SHORT: short*
- EINA_VALUE_TYPE_INT: int*
- EINA_VALUE_TYPE_LONG: long*
- EINA_VALUE_TYPE_INT64: int64_t*
- EINA_VALUE_TYPE_FLOAT: float*
- EINA_VALUE_TYPE_DOUBLE: double*
- EINA_VALUE_TYPE_STRINGSHARE: const char **
- EINA_VALUE_TYPE_STRING: const char **
- EINA_VALUE_TYPE_LIST: Eina_Value_List*
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash*
- EINA_VALUE_TYPE_TIMEVAL: struct timeval*
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob*
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct*

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x;
3
4 eina_value_list_append(value, 1234);
5 eina_value_list_get(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_vset()
  eina_value_list_pset()

Since
  1.2

static Eina_Bool eina_value_list_insert | ( | Eina_Value * | value,
|  | unsigned int | position,
|  |  | ...
| ) |  |
| inlinestatic

Insert the generic value in an list member position.

Parameters

  value | source value object
  position | index of the member

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The variable argument is dependent on chosen subtype. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char
- EINA_VALUE_TYPE_USHORT: unsigned short
- EINA_VALUE_TYPE_UINT: unsigned int
- EINA_VALUE_TYPE_ULONG: unsigned long
- EINA_VALUE_TYPE_UINT64: uint64_t
- EINA_VALUE_TYPE_CHAR: char
- EINA_VALUE_TYPE_SHORT: short
- EINA_VALUE_TYPE_INT: int
- EINA_VALUE_TYPE_LONG: long
- EINA_VALUE_TYPE_INT64: int64_t
- EINA_VALUE_TYPE_FLOAT: float
- EINA_VALUE_TYPE_DOUBLE: double
- EINA_VALUE_TYPE_STRINGSHARE: const char *
- EINA_VALUE_TYPE_STRING: const char *
- EINA_VALUE_TYPE_LIST: Eina_Value_List
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash
- EINA_VALUE_TYPE_TIMEVAL: struct timeval
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x;
3
4 eina_value_list_insert(value, 0, 1234);
5 eina_value_list_get(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_pset()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_append | ( | Eina_Value * | value,
|  |  | ...
| ) |  |
| inlinestatic

Append the generic value in an list.

Parameters

  value | source value object

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The variable argument is dependent on chosen subtype. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char
- EINA_VALUE_TYPE_USHORT: unsigned short
- EINA_VALUE_TYPE_UINT: unsigned int
- EINA_VALUE_TYPE_ULONG: unsigned long
- EINA_VALUE_TYPE_UINT64: uint64_t
- EINA_VALUE_TYPE_CHAR: char
- EINA_VALUE_TYPE_SHORT: short
- EINA_VALUE_TYPE_INT: int
- EINA_VALUE_TYPE_LONG: long
- EINA_VALUE_TYPE_INT64: int64_t
- EINA_VALUE_TYPE_FLOAT: float
- EINA_VALUE_TYPE_DOUBLE: double
- EINA_VALUE_TYPE_STRINGSHARE: const char *
- EINA_VALUE_TYPE_STRING: const char *
- EINA_VALUE_TYPE_LIST: Eina_Value_List
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash
- EINA_VALUE_TYPE_TIMEVAL: struct timeval
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x;
3
4 eina_value_list_append(value, 1234);
5 eina_value_list_get(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_pset()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_vset | ( | Eina_Value * | value,
|  | unsigned int | position,
|  | va_list | args
| ) |  |
| inlinestatic

Set the generic value in an list member.

Parameters

  value | source value object
  position | index of the member
  args | variable argument

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_pset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_vget | ( | const Eina_Value * | value,
|  | unsigned int | position,
|  | va_list | args
| ) |  |
| inlinestatic

Get the generic value from an list member.

Parameters

  value | source value object
  position | index of the member
  args | variable argument

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The value is returned in the variable argument parameter, the actual value is type-dependent, but usually it will be what is stored inside the object. There shouldn't be any memory allocation, thus the contents should not be freed.

See also
  eina_value_list_vset()
  eina_value_list_get()
  eina_value_list_pget()

Since
  1.2

static Eina_Bool eina_value_list_vinsert | ( | Eina_Value * | value,
|  | unsigned int | position,
|  | va_list | args
| ) |  |
| inlinestatic

Insert the generic value in an list member position.

Parameters

  value | source value object
  position | index of the member
  args | variable argument

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_pset()
  eina_value_list_insert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_vappend | ( | Eina_Value * | value,
|  | va_list | args
| ) |  |
| inlinestatic

Append the generic value in an list.

Parameters

  value | source value object
  args | variable argument

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vget()
  eina_value_list_pset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_pset | ( | Eina_Value * | value,
|  | unsigned int | position,
|  | const void * | ptr
| ) |  |
| inlinestatic

Set the generic value in an list member from pointer.

Parameters

  value | source value object
  position | index of the member
  ptr | pointer to specify the contents.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The pointer type is dependent on chosen value type. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char*
- EINA_VALUE_TYPE_USHORT: unsigned short*
- EINA_VALUE_TYPE_UINT: unsigned int*
- EINA_VALUE_TYPE_ULONG: unsigned long*
- EINA_VALUE_TYPE_UINT64: uint64_t*
- EINA_VALUE_TYPE_CHAR: char*
- EINA_VALUE_TYPE_SHORT: short*
- EINA_VALUE_TYPE_INT: int*
- EINA_VALUE_TYPE_LONG: long*
- EINA_VALUE_TYPE_INT64: int64_t*
- EINA_VALUE_TYPE_FLOAT: float*
- EINA_VALUE_TYPE_DOUBLE: double*
- EINA_VALUE_TYPE_STRINGSHARE: const char **
- EINA_VALUE_TYPE_STRING: const char **
- EINA_VALUE_TYPE_LIST: Eina_Value_List*
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash*
- EINA_VALUE_TYPE_TIMEVAL: struct timeval*
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob*
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct*

Note
  the pointer contents are written using the size defined by type. It can be larger than void* or uint64_t.

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x = 1234;
3
4 eina_value_list_append(value, 1234);
5 eina_value_list_pset(value, 0, &x);
6 eina_value_list_pget(value, 0, &x);
7 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_pget | ( | const Eina_Value * | value,
|  | unsigned int | position,
|  | void * | ptr
| ) |  |
| inlinestatic

Get the generic value to pointer from an list member.

Parameters

  value | source value object
  position | index of the member
  ptr | pointer to receive the contents.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The value is returned in pointer contents, the actual value is type-dependent, but usually it will be what is stored inside the object. There shouldn't be any memory allocation, thus the contents should not be freed.

The pointer type is dependent on chosen value type. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char*
- EINA_VALUE_TYPE_USHORT: unsigned short*
- EINA_VALUE_TYPE_UINT: unsigned int*
- EINA_VALUE_TYPE_ULONG: unsigned long*
- EINA_VALUE_TYPE_UINT64: uint64_t*
- EINA_VALUE_TYPE_CHAR: char*
- EINA_VALUE_TYPE_SHORT: short*
- EINA_VALUE_TYPE_INT: int*
- EINA_VALUE_TYPE_LONG: long*
- EINA_VALUE_TYPE_INT64: int64_t*
- EINA_VALUE_TYPE_FLOAT: float*
- EINA_VALUE_TYPE_DOUBLE: double*
- EINA_VALUE_TYPE_STRINGSHARE: const char **
- EINA_VALUE_TYPE_STRING: const char **
- EINA_VALUE_TYPE_LIST: Eina_Value_List*
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash*
- EINA_VALUE_TYPE_TIMEVAL: struct timeval*
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob*
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct*

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x;
3
4 eina_value_list_append(value, 1234);
5 eina_value_list_pget(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_vset()
  eina_value_list_pset()

Since
  1.2

static Eina_Bool eina_value_list_pinsert | ( | Eina_Value * | value,
|  | unsigned int | position,
|  | const void * | ptr
| ) |  |
| inlinestatic

Insert the generic value in an list member position from pointer.

Parameters

  value | source value object
  position | index of the member
  ptr | pointer to specify the contents.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The pointer type is dependent on chosen value type. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char*
- EINA_VALUE_TYPE_USHORT: unsigned short*
- EINA_VALUE_TYPE_UINT: unsigned int*
- EINA_VALUE_TYPE_ULONG: unsigned long*
- EINA_VALUE_TYPE_UINT64: uint64_t*
- EINA_VALUE_TYPE_CHAR: char*
- EINA_VALUE_TYPE_SHORT: short*
- EINA_VALUE_TYPE_INT: int*
- EINA_VALUE_TYPE_LONG: long*
- EINA_VALUE_TYPE_INT64: int64_t*
- EINA_VALUE_TYPE_FLOAT: float*
- EINA_VALUE_TYPE_DOUBLE: double*
- EINA_VALUE_TYPE_STRINGSHARE: const char **
- EINA_VALUE_TYPE_STRING: const char **
- EINA_VALUE_TYPE_LIST: Eina_Value_List*
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash*
- EINA_VALUE_TYPE_TIMEVAL: struct timeval*
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob*
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct*

Note
  the pointer contents are written using the size defined by type. It can be larger than void* or uint64_t.

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x = 1234;
3
4 eina_value_list_pinsert(value, 0, &x);
5 eina_value_list_pget(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2

static Eina_Bool eina_value_list_pappend | ( | Eina_Value * | value,
|  | const void * | ptr
| ) |  |
| inlinestatic

Append the generic value in an list from pointer.

Parameters

  value | source value object
  ptr | pointer to specify the contents.

Returns
  EINA_TRUE on success, EINA_FALSE otherwise.

The pointer type is dependent on chosen value type. The list for basic types:

- EINA_VALUE_TYPE_UCHAR: unsigned char*
- EINA_VALUE_TYPE_USHORT: unsigned short*
- EINA_VALUE_TYPE_UINT: unsigned int*
- EINA_VALUE_TYPE_ULONG: unsigned long*
- EINA_VALUE_TYPE_UINT64: uint64_t*
- EINA_VALUE_TYPE_CHAR: char*
- EINA_VALUE_TYPE_SHORT: short*
- EINA_VALUE_TYPE_INT: int*
- EINA_VALUE_TYPE_LONG: long*
- EINA_VALUE_TYPE_INT64: int64_t*
- EINA_VALUE_TYPE_FLOAT: float*
- EINA_VALUE_TYPE_DOUBLE: double*
- EINA_VALUE_TYPE_STRINGSHARE: const char **
- EINA_VALUE_TYPE_STRING: const char **
- EINA_VALUE_TYPE_LIST: Eina_Value_List*
- EINA_VALUE_TYPE_HASH: Eina_Value_Hash*
- EINA_VALUE_TYPE_TIMEVAL: struct timeval*
- EINA_VALUE_TYPE_BLOB: Eina_Value_Blob*
- EINA_VALUE_TYPE_STRUCT: Eina_Value_Struct*

Note
  the pointer contents are written using the size defined by type. It can be larger than void* or uint64_t.

1 Eina_Value *value = eina_value_list_new(EINA_VALUE_TYPE_INT);
2 int x = 1234;
3
4 eina_value_list_pappend(value, &x);
5 eina_value_list_pget(value, 0, &x);
6 eina_value_free(value);

See also
  eina_value_list_set()
  eina_value_list_get()
  eina_value_list_vset()
  eina_value_list_insert()
  eina_value_list_vinsert()
  eina_value_list_pinsert()
  eina_value_list_append()
  eina_value_list_vappend()
  eina_value_list_pappend()

Since
  1.2